##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (samplename)	= PkgName
# sampledir (sampledir)		= pkg-dirname = pkg-filename (ksm-xxx)
# sampleconf (sampleconf)	= config file name (no extension)
# sampledm (sampledm)		= the daemon (rc-script, rc-link, systemd.service)
# sample (sample)		= all others
##############################################################################

# Specfile for KSM-Backup

%define name		ksm-backup
%define version		3.0.1
%define release		3.2.0
%define _arch		noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _bindir		/usr/local/bin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	Backup software
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Other
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	ksm-backuppkg,ksm-backupcapab
Requires:	mailx, rsync, dialog
Requires:	ksm-lib-sh >= 5.0.1-0.0.0
#Provides:	ksm-backupd
#Conflicts:	ksm-backupd-other,libksm-backup == 0.0.0
#Obsoletes:	myksm-backupd

%description
This package contains the program ksm-backup, which will make incremental 
backups either local or over a network.

Please check/configure:
 /usr/local/etc/ksm-backup.conf

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/ksm-backup.conf
#%config %{_confdir}/ksm-backup.conf
#%config %{_scnfdir}/ksm-backup
%{_confdir}/ksm-backup.conf

#%attr(744,root,root)/%{_rcdir}/ksm-backupd
#%attr(777,root,root)%{_bindir}/rcksm-backupd

%attr(744,root,root)%{_bindir}/ksm-backup

%{_datadir}/RELEASE
%{_datadir}/VERSION
%{_datadir}/lang/ksm-backup.en

/usr/share/applications/KSM-Backup.desktop
%{_icondir}/16x16/apps/ksm-backup.png
%{_icondir}/22x22/apps/ksm-backup.png
%{_icondir}/32x32/apps/ksm-backup.png
%{_icondir}/48x48/apps/ksm-backup.png
%{_icondir}/64x64/apps/ksm-backup.png
%{_icondir}/128x128/apps/ksm-backup.png
#%{_icondir}/256x256/apps/ksm-backup.png
#%{_icondir}/512x512/apps/ksm-backup.png
#/usr/share/pixmaps/ksm-backup.png

#%docdir %{_man1dir}
#%{_man1dir}/ksm-backup.1.gz

%docdir %{_man8dir}
%{_man8dir}/ksm-backup.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
%{_docdir}/README.de

#---------------------- ORDER OF SCRIPTLETS ----------------------------------
# O=old pkg, N=new pkg

# INSTALL:
# 1. Run %pre section of N		(Arg is 1)
# 2. Install files from N
# 3. Run %post section of N		(Arg is 1)

# UNINSTALL:
# 1. Run %preun section of O		(Arg is 0)
# 2. Delete files from O
# 3. Run %postun section of O		(Arg is 0)

# UPGRADE:
#  1. Run %pre section of O		(Arg is 2)
#  2. Install files from N
#  3. Run %post section of N		(Arg is 2)
#  4. Execute install. triggers (%triggerin in other pkgs) set off by install N
#  5. Execute installation triggers of N
#  6. Execute uninstallation triggers (%triggerun) of O
#  7. Execute uninstallation triggers (of other pkgs) set off by uninstall O
#  8. Run %preun section of O		(Arg is 1)
#  9. Delete files from O not contained in N
# 10. Run %postun section of O		(Arg is 1)

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# backup config files
test -e %{_confdir}/ksm-backup.conf && cp %{_confdir}/ksm-backup.conf %{_confdir}/ksm-backup.conf.rpmsave
#test -e %{_scnfdir}/ksm-backup && cp %{_scnfdir}/ksm-backup %{_scnfdir}/ksm-backup.rpmsave

# disable ksm-backup and stop ksm-backupd
#test -x %{_bindir}/toggleksm-backup && %{_bindir}/toggleksm-backup -d -q > /dev/null 2>&1
#test -x %{_rcdir}/ksm-backupd && %{_rcdir}/ksm-backupd stop > /dev/null 2>&1

# remove links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog

# uninstall desktop files
xdg-desktop-menu uninstall \
	/usr/share/applications/KSM-Backup.desktop

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# set config pathname. config file needs a version at first cnfvar!
cf=%{_confdir}/ksm-backup.conf
cnfvars=$(grep -v '^#' $cf | grep '[[:alnum:]]' | grep -v '\[' | cut -sd '=' -f1)
cnfvars=$(echo $cnfvars | cut -d ' ' -f2-)

# enable ksm-backup and stop ksm-backupd
#test -x %{_bindir}/toggleksm-backup && %{_bindir}/toggleksm-backup -s -q > /dev/null 2>&1
#test -x %{_rcdir}/ksm-backupd && %{_rcdir}/ksm-backupd start > /dev/null 2>&1

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog

# install desktop files
xdg-desktop-menu install --novendor \
	/usr/share/applications/KSM-Backup.desktop

if [ "$1" == 1 ]; then					# install package
	echo "Please configure $cf"
#	echo "Users must create HOME/.ksm-backuprc with update-ksm-backup"
else							# upgrade package

	# update global conf
	if [ -e $cf.rpmsave ]; then
		#cp $cf $cf.rpmnew
		. $cf
		. $cf.rpmsave
		# update conf vars START -------------------------------------
		if [ -x %{_bindir}/replcnfvar ]; then
			for c in $cnfvars; do
				t="\$$c"
				eval s="$t"
				s=\"$s\"
				%{_bindir}/replcnfvar $cf $c "$s"
			done
		else
			echo "Error - cmd replcnfvar not found or not executable!" >&2
			echo "Conf file not updated!" >&2
		fi
		# update conf vars STOP --------------------------------------

		# update array vars START ------------------------------------
		# array var SRCARR
		cnt=${#SRCARR[@]}			# max index of array
		i=0
		if [ "$cnt" -gt 0 ]; then		# any arrays in use?
			while [ "$i" -lt $cnt ]; do
				let i++
				# array SRCARR
				s="SRCARR[$i]=\"${SRCARR[$i]}\""
				echo "$s" >> $cf	# append to conf file
			done
		fi
		# update array vars STOP -------------------------------------

		diff $cf $cf.rpmsave > /dev/null 2>&1
		ret=$?
		if [ "$ret" -eq 0 ]; then
			rm $cf.rpmsave
		else
			echo "Please check $cf"
		fi
	fi

#	echo "If new version then users must update HOME/.ksm-backuprc with update-ksm-backup"
fi
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	# backup config files
	test -e %{_confdir}/ksm-backup.conf && cp %{_confdir}/ksm-backup.conf %{_confdir}/ksm-backup.conf.rpmsave
	#test -e %{_scnfdir}/ksm-backup && cp %{_scnfdir}/ksm-backup %{_scnfdir}/ksm-backup.rpmsave

	# disable ksm-backup and stop ksm-backupd
	#test -x %{_bindir}/toggleksm-backup && %{_bindir}/toggleksm-backup -d -q > /dev/null 2>&1
	#test -x %{_rcdir}/ksm-backupd && %{_rcdir}/ksm-backupd stop > /dev/null 2>&1

	# remove links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog

	# uninstall desktop files
	xdg-desktop-menu uninstall \
		/usr/share/applications/KSM-Backup.desktop
#else							# upgrade package
fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/ksm-backup
#else							# upgrade package
fi
exit 0

%changelog
* Tue Dec 05 2023 Repomaster <repomaster@kaesmann-online.de> 3.0.1-3.2.0
- The package has been revised/improved.

* Fri Sep 22 2023 Repomaster <repomaster@kaesmann-online.de> 3.0.1-3.1.0
- The package has been revised/improved
  (corrected false version in conf file).

* Thu Apr 06 2023 Repomaster <repomaster@kaesmann-online.de> 3.0.1-3.0.0
- The package has been revised/improved
  (the desktop file has been renamed from
  ksm-backup.desktop to KSM-Backup.desktop).
- 'KSM-Backup' has been revised/improved
  (removing one menu entry and renaming an
  other).

* Fri Mar 03 2023 Repomaster <repomaster@kaesmann-online.de> 3.0.1-2.0.0
- 'ksm-backup' has been revised/improved.

* Mon Dec 12 2022 Repomaster <repomaster@kaesmann-online.de> 3.0.1-1.1.0
- 'ksm-backup' has been revised/improved
  (dialog functions).

* Mon Nov 14 2022 Repomaster <repomaster@kaesmann-online.de> 3.0.1-1.0.0
- 'ksm-backup' has been revised/improved
  (better use of big terminals).

* Fri Apr 08 2022 Repomaster <repomaster@kaesmann-online.de> 3.0.1-0.0.0
- 'ksm-backup' has been revised/improved
  (Name of backup files has been changed
  to a long form YYYY-MM-DD_ksm-backup).

* Sat Mar 26 2022 Repomaster <repomaster@kaesmann-online.de> 3.0.0-2.0.0
- 'ksm-backup' has been revised/improved.

* Sun Feb 06 2022 Repomaster <repomaster@kaesmann-online.de> 3.0.0-1.0.0
- 'ksm-backup' has been revised/improved.

* Thu Jan 06 2022 Repomaster <repomaster@kaesmann-online.de> 3.0.0-0.0.0
- Update to the libfuncstd-sh 4.0.0

* Sun Jan 02 2022 Repomaster <repomaster@kaesmann-online.de> 2.0.1-0.0.0
- 'ksm-backup' has been revised/improved
  (also the conf file has been changed).

* Sun Jan 02 2022 Repomaster <repomaster@kaesmann-online.de> 2.0.0-1.0.0
- 'ksm-backup' has been revised/improved
  (fixed errors with the dialog system).

* Thu Dec 23 2021 Repomaster <repomaster@kaesmann-online.de> 2.0.0-0.0.0
- 'ksm-backup' has been revised/improved
  (the UI has changed - now we use dialog,
  fixed some errors).
  (removed -v, -q, added -a).

* Mon Feb 24 2020 Repomaster <repomaster@kaesmann-online.de> 1.3.0-0.2.0
- ksm-backup has been revised/improved
  (added icons).

* Thu Feb 14 2019 Repomaster <repomaster@kaesmann-online.de> 1.3.0-0.1.0
- ksm-backup has been revised/improved
  (error by wrong name of archive array).

* Tue Dec 11 2018 Repomaster <repomaster@kaesmann-online.de> 1.3.0-0.0.0
- ksm-backup has been revised
  (error in evaluation of options).

* Mon Dec 10 2018 Repomaster <repomaster@kaesmann-online.de> 1.2.0-0.0.0
- ksm-backup has been revised
  (The config file has changed).

* Wed Nov 21 2018 Repomaster <repomaster@kaesmann-online.de> 1.1.0-2.10.0
- ksm-backup has been revised
  (cmd mount may exist in different dirs).

* Mon Nov 19 2018 Repomaster <repomaster@kaesmann-online.de> 1.1.0-2.9.0
- The docu has revised
  (added a flowchart).
- The system prog 'mount' has been moved
  from /bin/ to /usr/bin/

* Sun Dec 10 2017 Repomaster <repomaster@kaesmann-online.de> 1.1.0-2.8.0
- ksm-backup has been revised
  (extra full backup not longer needed).

* Wed Apr 12 2017 Repomaster <repomaster@kaesmann-online.de> 1.1.0-2.7.0
- ksm-backup has been revised
  (modified destination of link LAST-KSM-BACKUP).

* Sun Jan 22 2017 Repomaster <repomaster@kaesmann-online.de> 1.1.0-2.6.0
- All scripts have been revised
  (using function GetOpt).

* Mon Jan 16 2017 Repomaster <repomaster@kaesmann-online.de> 1.1.0-2.5.0
- All scripts have been revised.

* Tue Oct 04 2016 Repomaster <repomaster@kaesmann-online.de> 1.1.0-2.4.0
- The script ksm-backup has been revised
  (removing incremental backups).

* Mon Oct 03 2016 Repomaster <repomaster@kaesmann-online.de> 1.1.0-2.3.0
- The script ksm-backup has been revised.

* Mon Oct 03 2016 Repomaster <repomaster@kaesmann-online.de> 1.1.0-2.2.0
- The script ksm-backup has been revised
  (LOG-Output).

* Mon Oct 03 2016 Repomaster <repomaster@kaesmann-online.de> 1.1.0-2.1.0
- The script ksm-backup has been revised
  (LOG-Output, rm allready existing incremental backup).

* Mon Sep 12 2016 Repomaster <repomaster@kaesmann-online.de> 1.1.0-2.0.0
- The script ksm-backup has been revised
  (Now the leading dates in dir names are
  separated with a '_').

* Sat Apr 09 2016 Repomaster <repomaster@kaesmann-online.de> 1.1.0-1.0.0
- The script ksm-backup has been revised
  (fixed error in 1. incremental backup when
  LAST-KSM-BACKUP does not exist).

* Fri Apr 08 2016 Repomaster <repomaster@kaesmann-online.de> 1.1.0-0.0.0
- Added desktop file for KDE.

* Wed Apr 06 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.0-0.0.0
- Added multi language support.

* Mon Apr 04 2016 Repomaster <repomaster@kaesmann-online.de> 0.2.0-0.0.1
- Tho docu of the package has been revised.

* Mon Apr 04 2016 Repomaster <repomaster@kaesmann-online.de> 0.2.0-0.0.0
- The script ksm-backup has been revised.

* Mon Apr 04 2016 Repomaster <repomaster@kaesmann-online.de> 0.1.0-0.2.1
- The docu of the package has been revised.

* Mon Apr 04 2016 Repomaster <repomaster@kaesmann-online.de> 0.1.0-0.2.0
- The script ksm-backup has been revised.
- Fixed error using SSH.
- Fixed error using cmd -r.

* Sat Apr 02 2016 Repomaster <repomaster@kaesmann-online.de> 0.1.0-0.1.0
- Fixed errors around cmd LN.

* Sat Apr 02 2016 Repomaster <repomaster@kaesmann-online.de> 0.1.0-0.0.0
- Added the functionality of network backups.

* Thu Mar 31 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.2-0.1.0
- The script ksm-backup has been revised.
  Fixed output to screen even if in silent mode.
  The output to log and screen has been modified.

* Wed Mar 30 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.2-0.0.0
- The script ksm-backup has been revised.
  The file /root/.ksm-backup/ksm-backup.last
  has been removed.

* Tue Mar 29 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.3.1
- The Docu of the package has been revised.

* Tue Mar 29 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.3.0
- The script ksm-backup has been revised.

* Tue Mar 29 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.2.0
- The script ksm-backup has been revised
  (added support for removing incremental backups).

* Mon Mar 28 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.1.0
- Added cmd -r to ksm-backup.

* Fri Mar 25 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.0.0
- The package has been revised.

* Fri Mar 25 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.0-0.0.0
- This is the 1. version.
- The package contains following programs:
  ksm-backup:	Make backups
